## dietlibc 0.33~cvs20110918

=== test/Makefile ===
all: direnttest inet stdiotests stdlibtests stringtests timetests \
test ffs getdelim stdlib 

DIET=diet
CC=gcc
CFLAGS=-nostdinc -Wall

LCOMPAT=-lcompat

TESTPROGRAMS=adjtime alarm argv asprintf atexit bsearch byteswap calloc confstr cycles empty fadvise flush fnmatch \
fputc ftw fwrite getaddrinfo getenv getgrnam gethostbyaddr gethostbyname \
gethostbyname_r getmntent getopt getpass getpwnam getservbyname getservbyport getusershell \
glob grent hasmntopt hello iconv if_nameindex ltostr malloc-debugger md5_testharness \
memccpy memchr memcmp memrchr memusage mktime mmap_test pipe printf printftest \
protoent prototypes putenv pwent rand48 read1 readdir regex select sendfile servent siglist \
speed spent sprintf sscanf stdarg strcasecmp strcmp strncat strncpy strptime strrchr \
strstr strtol sysenter ungetc utime waitpid

test: $(TESTPROGRAMS)

ffs: ffs.c
	$(DIET) $(CC) $(CFLAGS) $^ $(LCOMPAT) -o $@
	
getdelim: getdelim.c
	$(DIET) $(CC) $(CFLAGS) $^ $(LCOMPAT) -o $@ 

syscall: syscall.c
	$(DIET) $(CC) $^ -o $@

testandset: testandset.c
	$(DIET) $(CC) $^ -o $@ 

direnttest:
	 $(MAKE) -C dirent CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)

inettest:
	$(MAKE) -C inet CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)

stdiotests:
	$(MAKE) -C stdio CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)

stdlibtests:
	$(MAKE) -C stdlib CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)

stringtests:
	$(MAKE) -C string CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)

timetests:
	$(MAKE) -C time CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)
	
	
%: %.c
	$(DIET) $(CC) $(CFLAGS) $^ -o $@

clean:
	rm -f $(TESTPROGRAMS) getdelim ffs
	$(MAKE) -C dirent clean
	$(MAKE) -C stdio clean
	$(MAKE) -C stdlib clean
	$(MAKE) -C string clean
	$(MAKE) -C time clean

=== debian/changelog ===
dietlibc (0.33~cvs20110918-4) unstable; urgency=low

  * d/rules: disable tc523086.c test on ARM (segfaults on armhf) 

 -- Hector Oron <zumbi@debian.org>  Fri, 07 Oct 2011 17:33:34 +0100

dietlibc (0.33~cvs20110918-3) unstable; urgency=low

  [ Thorsten Glaser ]
  * d/control: do not Recommend or Suggest the dietlibc package
    which is currently not built for any architecture
  * d/control: move homepage link from Description into its header

 -- Hector Oron <zumbi@debian.org>  Thu, 06 Oct 2011 13:51:39 +0100

dietlibc (0.33~cvs20110918-2) unstable; urgency=low

  * d/patches/fix-ppc64-ftbfs.diff: Fix FTBFS (Closes: #644405)
    - Thanks Hiroyuki Yamamoto for the fix

 -- Hector Oron <zumbi@debian.org>  Thu, 06 Oct 2011 13:17:24 +0100

dietlibc (0.33~cvs20110918-1) experimental; urgency=low

  [ Hector Oron ]
  * Update to cvs20110918. 
    - Fixes memchr('\0') (Closes: #582654)

  [ Thorsten Glaser ]
  * d/control: mention dynamic linking is currently disabled

 -- Hector Oron <zumbi@debian.org>  Sun, 18 Sep 2011 10:33:12 +0200

dietlibc (0.33~cvs20110710-2) experimental; urgency=low

  [ Hector Oron ]
  * Fix build for ARMv7 arches.
  * Fix FTBFS on s390. 
  * Drop 0015-arm-soft-and-hard-support.diff 

  [ Thorsten Glaser ]
  * d/diff/0017-disable-propolice: fix FTBFS on SSP-by-default gcc
  * d/diff/0018-manpage: fix manpage

 -- Hector Oron <zumbi@debian.org>  Sat, 17 Sep 2011 13:09:44 +0100

=== debian/control ===
Source: dietlibc
Section: devel
Priority: optional
Homepage: http://www.fefe.de/dietlibc/
Maintainer: Hector Oron <zumbi@debian.org>
Uploaders: Gerrit Pape <pape@smarden.org>, Thorsten Glaser <tg@mirbsd.de>
Standards-Version: 3.9.2

Package: dietlibc-dev
Section: libdevel
Architecture: alpha amd64 arm armel armeb armhf hppa i386 ia64 mips mipsel powerpc ppc64 s390 sparc
Suggests: dietlibc-doc
Description: diet libc - a libc optimized for small size
 The diet libc is a C library that is optimized for small size. It
 can be used to create small statically linked binaries for Linux
 on alpha, arm, ia64, mips, mipsel, ppc, parisc, s390, sparc and x86.
 .
 This package is used to compile programs with the diet libc.
 .
 The diet libc also supports dynamic linking, but this has been
 temporarily disabled because of problems with it.

Package: dietlibc-doc
Architecture: all
Section: doc
Suggests: dietlibc-dev
Description: diet libc documentation - a libc optimized for small size
 The diet libc is a C library that is optimized for small size. It
 can be used to create small statically linked binaries for Linux
 on alpha, arm, ia64, mips, mipsel, ppc, parisc, s390, sparc and x86.
 .
 This package contains the documentation for the diet libc.
 .
 The diet libc also supports dynamic linking, but this has been
 temporarily disabled because of problems with it.

=== debian/rules ===
#!/usr/bin/make -f

# determine whether we are cross-compiling
DEB_BUILD_GNU_TYPE:=$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE:=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
ifeq (${DEB_BUILD_GNU_TYPE},${DEB_HOST_GNU_TYPE})
CROSS:=0
else
CROSS:=1
endif

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
  DEBUG =DEBUG=1
else
  DEBUG =
endif

ARCH ?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
ifeq ($(ARCH),amd64)
  ARCH =x86_64
else
ifeq ($(ARCH),powerpc)
  ARCH =ppc
else
ifeq ($(ARCH),hppa)
  ARCH =parisc
else
ifeq ($(ARCH),mipsel)
  ARCH =mips
else
ifneq (,$(findstring arm,$(ARCH)))
  ARCH =arm
# DEBUG =DEBUG=1
endif
endif
endif
endif
endif

DYN =0
ifneq ($(ARCH),i386)
  DYN =0
endif

DIR =$(shell pwd)/debian/dietlibc
VERSION =$(shell head -n1 debian/changelog |sed -e 's/.*(\(.*\)).*/\1/')

patch: deb-checkdir patch-stamp
patch-stamp:
	for i in `ls -1 debian/diff/*.diff || :`; do \
	  patch -p1 <$$i || exit 1; \
	done
	touch patch-stamp

build: deb-checkdir build-stamp
build-stamp: patch-stamp
	#rm -f parisc/strstr.S
	$(MAKE) prefix=/usr/lib/diet \
	  MYARCH='$(ARCH)' VERSION='$(VERSION)' $(DEBUG)
ifeq (${CROSS},0)
	bin-'$(ARCH)'/diet -v -Os gcc -nostdinc -o ttt test/select.c
	./ttt
	rm -f ttt
# Disable test on ARM (armhf segfaults)
ifneq (,$(findstring arm,$(ARCH)))
	bin-'$(ARCH)'/diet -v -Os gcc -nostdinc -static -o ttt debian/test/tc523086.c
	./ttt
	rm -f ttt
endif
endif
	test '$(DYN)' -eq 0 || \
	  $(MAKE) dyn prefix=/usr/lib/diet \
	    MYARCH='$(ARCH)' VERSION='$(VERSION)' $(DEBUG)
	touch build-stamp

clean: deb-checkdir deb-checkuid
	$(MAKE) clean MYARCH='$(ARCH)'
	test ! -e patch-stamp || \
	  for i in `ls -1r debian/diff/*.diff || :`; do patch -p1 -R <$$i; done
	rm -f build-stamp install-stamp patch-stamp
	rm -f dynlinker.README libdl.README libpthread.CHANGES \
	  libpthread.README profiling.PORTING profiling.README \
	  sparc64.README ia64.README changelog
	rm -rf '$(DIR)' '$(DIR)'-dev '$(DIR)'-doc
	rm -f debian/files debian/substvars debian/dietlibc-dev.postinst \
	  debian/dietlibc-dev.prerm

install: deb-checkdir deb-checkuid install-stamp
install-stamp: build-stamp
	rm -rf '$(DIR)' '$(DIR)'-dev '$(DIR)'-doc
	install -d -m0755 '$(DIR)'/etc
	$(MAKE) install prefix=/usr/lib/diet DESTDIR='$(DIR)' \
	  MYARCH='$(ARCH)' VERSION='$(VERSION)' $(DEBUG)
	# dietlibc dietlibc-dev dietlibc-doc
	echo '/usr/lib/diet/lib' >'$(DIR)'/etc/diet.ld.conf
	install -d -m0755 '$(DIR)'-dev/usr/include
	mv '$(DIR)'/usr/lib/diet/include '$(DIR)'-dev/usr/include/diet
	install -d -m0755 '$(DIR)'-dev/usr/lib/diet
	ln -s ../../include/diet '$(DIR)'-dev/usr/lib/diet/include
	mv '$(DIR)'/usr/lib/diet/lib-'$(ARCH)' '$(DIR)'/usr/lib/diet/lib
	cp -pr '$(DIR)'/usr/lib/diet/lib '$(DIR)'-dev/usr/lib/diet/
	rm -f '$(DIR)'/usr/lib/diet/lib/*.[ao]
	rm -f '$(DIR)'-dev/usr/lib/diet/lib/*.so
	#ln -s lib '$(DIR)'-dev/usr/lib/diet/lib-'$(ARCH)'
	mv '$(DIR)'/usr/lib/diet/bin '$(DIR)'-dev/usr/lib/diet/
	install -d -m0755 '$(DIR)'-dev/usr/bin
	mv '$(DIR)'-dev/usr/lib/diet/bin/diet* '$(DIR)'-dev/usr/bin/
	ln -s ../../../bin/diet '$(DIR)'-dev/usr/lib/diet/bin/
	strip '$(DIR)'-dev/usr/lib/diet/bin/dnsd
	strip '$(DIR)'-dev/usr/lib/diet/bin/elftrunc
	if test '$(DYN)' -eq 1; then \
	  ln -s ../../../bin/diet-dyn '$(DIR)'-dev/usr/lib/diet/bin/ && \
	  chmod 0644 '$(DIR)'/usr/lib/diet/lib/*.so && \
	  chmod 0755 '$(DIR)'/usr/lib/diet/lib/libdl.so; \
	fi
	install -d -m0755 $(DIR)-dev/usr/share/man
	mv $(DIR)/usr/lib/diet/man/man? $(DIR)-dev/usr/share/man/
	gzip -9 $(DIR)-dev/usr/share/man/man?/*
	rmdir $(DIR)/usr/lib/diet/man
	install -d -m0755 $(DIR)-doc
	# .in
	sed -e 's/|ARCH|/$(ARCH)/g' <debian/dietlibc-dev.postinst.in \
	  >debian/dietlibc-dev.postinst
	sed -e 's/|ARCH|/$(ARCH)/g' <debian/dietlibc-dev.prerm.in \
	  >debian/dietlibc-dev.prerm
	# lintian overrides
	install -d -m0755 '$(DIR)'-dev/usr/share/lintian/overrides
	install -m0644 debian/dietlibc-dev.lintian \
	  '$(DIR)'-dev/usr/share/lintian/overrides/dietlibc-dev
	# doc
	rm -f dynlinker.README libdl.README libpthread.CHANGES \
	  libpthread.README profiling.PORTING profiling.README \
	  sparc64.README ia64.README changelog
	ln -s dynlinker/README dynlinker.README
	ln -s libdl/README libdl.README
	ln -s libpthread/CHANGES libpthread.CHANGES
	ln -s libpthread/README libpthread.README
	ln -s profiling/PORTING profiling.PORTING
	ln -s profiling/README profiling.README
	ln -s sparc64/README sparc64.README
	ln -s ia64/README ia64.README
	ln -s CHANGES changelog
	touch install-stamp

binary-indep: deb-checkdir deb-checkuid install dietlibc-doc.deb
	dpkg-gencontrol -isp -pdietlibc-doc -P'$(DIR)'-doc
	dpkg -b '$(DIR)'-doc ..

binary-arch: deb-checkdir deb-checkuid install dietlibc-dev.deb dietlibc.deb
	dpkg-gencontrol -isp -pdietlibc-dev -P'$(DIR)'-dev
	dpkg -b '$(DIR)'-dev ..
	if test '$(DYN)' -eq 1; then \
	  dpkg-gencontrol -isp -pdietlibc -P'$(DIR)'; \
	  dpkg -b '$(DIR)' ..; \
	fi

binary: binary-indep binary-arch
.PHONY: patch build clean install binary-indep binary-arch binary

include debian/implicit

## dietlibc 0.33~cvs20111108

=== debian/changelog ===
dietlibc (0.33~cvs20111108-5) unstable; urgency=low

  * Really fix s390 (Probably Closes: #523110)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 20 Nov 2011 16:52:41 +0000

dietlibc (0.33~cvs20111108-4) unstable; urgency=low

  [ Thorsten Glaser ]
  * “Schlösser Alt” upload
  * Patch to fix the ssize_t definition, for -Wformat benefit
  * Testcase to catch a specifically aligned strlen bug, from
    mtest-ascii1 of the Debian mksh package
  * Patch for string functions to not read past end of allocation
  * Patch to make strtod not use 'long double' on alpha, sparc
    (and sparc64) to make it link again (Closes: #547404)

  [ Bastian Blank ]
  * Patch to fix sigsetjmp on s390 (Closes: #523110)

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 19 Nov 2011 21:15:46 +0000

dietlibc (0.33~cvs20111108-3) unstable; urgency=low

  * The team of Héctor and me seems to have taken over well enough
    to close the ITA and drop Gerrit from Uploaders (Closes: #544060)
  * Upload to unstable
  * Enable s390x and sparc64 architectures, which are supported
    upstream, and see what happens

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 11 Nov 2011 18:06:11 +0000

dietlibc (0.33~cvs20111108-2) experimental; urgency=low

  * Remove parisc/strstr.S again (Closes: #523086)
  * Next attempt: use = instead of .equ or .set

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 10 Nov 2011 18:06:15 +0000

dietlibc (0.33~cvs20111108-1) experimental; urgency=low

  * debian/rules: New target "get-orig-source" to automate the
    process of exporting a CVS snapshot, without the CVS dirs,
    replace CR-LF line endings with LF ones, and tar it up
  * Update to cvs20111108
  * Use .equ instead of .set so it compiles on alpha
  * Honour nostrip for the diet* binaries, too (Closes: #436767)
  * Fix "debian/rules clean" not removing a ttt (test) binary
  * Make "lintian -vIiE --pedantic" clean
  * Repair ARM mmap syscall (Paul Brook, Timo Juhani Lindfors)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 08 Nov 2011 22:36:48 +0000

dietlibc (0.33~cvs20110918-5) experimental; urgency=low

  * Remove more mentions of the gone dynamic linking support
  * quilt refresh all patches
  * Pass -fno-stack-protector from diet to gcc when dietlibc is
    compiled without SSP support because otherwise programs will
    segfault, as dietlibc does not set up the registers needed
  * Re-enable tc523086, as I believe the testcase is right, and
    if an armhf buildd fails, the buildd is bad (Closes: #644646)
  * Fix all lintian warnings except CVS in orig.tar.gz
    - debian/copyright Format URI, fix format (spurious newline)
    - add comment to d/patches/0014-sparc_v9-does-not-imply-arch64
    - remove the .comment section when stripping binaries
  * Honour DEB_BUILD_OPTIONS=nostrip as well

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 03 Nov 2011 21:33:39 +0000

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Homepage: http://www.fefe.de/dietlibc/
 Maintainer: Hector Oron <zumbi@debian.org>
-Uploaders: Gerrit Pape <pape@smarden.org>, Thorsten Glaser <tg@mirbsd.de>
+Uploaders: Thorsten Glaser <tg@mirbsd.de>
 Standards-Version: 3.9.2
 
 Package: dietlibc-dev
 Section: libdevel
-Architecture: alpha amd64 arm armel armeb armhf hppa i386 ia64 mips mipsel powerpc ppc64 s390 sparc
+Architecture: alpha amd64 arm armeb armel armhf hppa i386 ia64 mips mipsel powerpc ppc64 s390 s390x sparc sparc64
 Suggests: dietlibc-doc
 Description: diet libc - a libc optimized for small size
  The diet libc is a C library that is optimized for small size. It
@@ -30,6 +30,3 @@
  on alpha, arm, ia64, mips, mipsel, ppc, parisc, s390, sparc and x86.
  .
  This package contains the documentation for the diet libc.
- .
- The diet libc also supports dynamic linking, but this has been
- temporarily disabled because of problems with it.

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,8 @@
 #!/usr/bin/make -f
+
+# for "debian/rules get-orig-source"
+ORIGTGZ_SOURCE:=	-D'2011/11/08 20:00'
+ORIGTGZ_DESTINATION:=	0.33~cvs20111108
 
 # determine whether we are cross-compiling
 DEB_BUILD_GNU_TYPE:=$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
@@ -45,28 +49,21 @@
 DIR =$(shell pwd)/debian/dietlibc
 VERSION =$(shell head -n1 debian/changelog |sed -e 's/.*(\(.*\)).*/\1/')
 
-patch: deb-checkdir patch-stamp
-patch-stamp:
-	for i in `ls -1 debian/diff/*.diff || :`; do \
-	  patch -p1 <$$i || exit 1; \
-	done
-	touch patch-stamp
-
 build: deb-checkdir build-stamp
-build-stamp: patch-stamp
-	#rm -f parisc/strstr.S
+build-stamp:
+	rm -f parisc/strstr.S
 	$(MAKE) prefix=/usr/lib/diet \
 	  MYARCH='$(ARCH)' VERSION='$(VERSION)' $(DEBUG)
 ifeq (${CROSS},0)
 	bin-'$(ARCH)'/diet -v -Os gcc -nostdinc -o ttt test/select.c
 	./ttt
 	rm -f ttt
-# Disable test on ARM (armhf segfaults)
-ifneq (,$(findstring arm,$(ARCH)))
 	bin-'$(ARCH)'/diet -v -Os gcc -nostdinc -static -o ttt debian/test/tc523086.c
 	./ttt
 	rm -f ttt
-endif
+	bin-'$(ARCH)'/diet -v -Os gcc -nostdinc -static -o ttt debian/test/t-ascii1.c
+	./ttt
+	rm -f ttt
 endif
 	test '$(DYN)' -eq 0 || \
 	  $(MAKE) dyn prefix=/usr/lib/diet \
@@ -75,9 +72,7 @@
 
 clean: deb-checkdir deb-checkuid
 	$(MAKE) clean MYARCH='$(ARCH)'
-	test ! -e patch-stamp || \
-	  for i in `ls -1r debian/diff/*.diff || :`; do patch -p1 -R <$$i; done
-	rm -f build-stamp install-stamp patch-stamp
+	rm -f build-stamp install-stamp ttt
 	rm -f dynlinker.README libdl.README libpthread.CHANGES \
 	  libpthread.README profiling.PORTING profiling.README \
 	  sparc64.README ia64.README changelog
@@ -106,8 +101,14 @@
 	install -d -m0755 '$(DIR)'-dev/usr/bin
 	mv '$(DIR)'-dev/usr/lib/diet/bin/diet* '$(DIR)'-dev/usr/bin/
 	ln -s ../../../bin/diet '$(DIR)'-dev/usr/lib/diet/bin/
-	strip '$(DIR)'-dev/usr/lib/diet/bin/dnsd
-	strip '$(DIR)'-dev/usr/lib/diet/bin/elftrunc
+ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
+	strip -s -R .comment '$(DIR)'-dev/usr/bin/diet
+	if test '$(DYN)' -eq 1; then \
+	  strip -s -R .comment '$(DIR)'-dev/usr/bin/diet-dyn; \
+	fi
+	strip -s -R .comment '$(DIR)'-dev/usr/lib/diet/bin/dnsd
+	strip -s -R .comment '$(DIR)'-dev/usr/lib/diet/bin/elftrunc
+endif
 	if test '$(DYN)' -eq 1; then \
 	  ln -s ../../../bin/diet-dyn '$(DIR)'-dev/usr/lib/diet/bin/ && \
 	  chmod 0644 '$(DIR)'/usr/lib/diet/lib/*.so && \
@@ -155,6 +156,30 @@
 	fi
 
 binary: binary-indep binary-arch
-.PHONY: patch build clean install binary-indep binary-arch binary
+.PHONY: build clean install binary-indep binary-arch binary
 
 include debian/implicit
+
+_ANONCVSROOT:=		:pserver:cvs@cvs.fefe.de:/cvs
+_CVSEXPORT:=		env CVS_RSH=ssh TZ=UTC cvs -qd ${_ANONCVSROOT} -z9 export
+ifneq (,$(wildcard /usr/bin/mircpio))
+_PACK:=			find dietlibc-${ORIGTGZ_DESTINATION} -type f | sort | \
+			    mircpio -oC512 -Hustar -Mdist
+else
+_PACK:=			tar -cf - dietlibc-${ORIGTGZ_DESTINATION}
+endif
+
+get-orig-source:
+	rm -rf $@.tmp
+	mkdir $@.tmp
+	# to get a Debian .orig.tar.gz we need to pull the source from CVS
+	cd $@.tmp; ${_CVSEXPORT} ${ORIGTGZ_SOURCE} dietlibc
+	# fixup files with CR-LF line endings
+	cd $@.tmp; find dietlibc -type f -print0 | \
+	    xargs -0 perl -pi -e 's/\r$$//' --
+	# then rename and pack it up
+	mv $@.tmp/dietlibc $@.tmp/dietlibc-${ORIGTGZ_DESTINATION}
+	cd $@.tmp; ${_PACK} | gzip -n9 >../dietlibc_${ORIGTGZ_DESTINATION}.orig.tar.gz
+	rm -rf $@.tmp
+	# there we are...
+	ls -l dietlibc_${ORIGTGZ_DESTINATION}.orig.tar.gz

## dietlibc 0.33~cvs20120325

=== Makefile ===
INSTALL=install
prefix?=/opt/diet
# Set the following to install to a different root
#DESTDIR=/tmp/fefix
# Use "make DEBUG=1" to compile a debug version.

LIBDIR=${prefix}/lib
BINDIR=${prefix}/bin
MAN1DIR=${prefix}/man/man1

MYARCH:=$(shell uname -m | sed -e 's/i[4-9]86/i386/' -e 's/armv[3-6]t\?e\?[lb]/arm/')

# This extra-ugly cruft is here so make will not run uname and sed each
# time it looks at $(OBJDIR).  This alone sped up running make when
# nothing has to be done from 1 sec to 0.12 sec on a 900 MHz Athlon.
# We don't use ARCH:=$(MYARCH) so we can detect unknown architectures.
ifeq ($(MYARCH),i386)
ARCH=i386
else
ifeq ($(MYARCH),mips)
ARCH=mips
else
ifeq ($(MYARCH),alpha)
ARCH=alpha
else
ifeq ($(MYARCH),ppc)
ARCH=ppc
else
ifeq ($(MYARCH),ppc64)
ARCH=ppc64
else
ifeq ($(MYARCH),arm)
ARCH=arm
else
ifeq ($(MYARCH),sparc)
ARCH=sparc
else
ifeq ($(MYARCH),sparc64)
ARCH=sparc64
else
ifeq ($(MYARCH),s390)
ARCH=s390
else
ifeq ($(MYARCH),s390x)
ARCH=s390x
else
ifeq ($(MYARCH),mipsel)
ARCH=mipsel
else
ifeq ($(MYARCH),parisc)
ARCH=parisc
else
ifeq ($(MYARCH),parisc64)
ARCH=parisc
MYARCH=parisc
else
ifeq ($(MYARCH),x86_64)
ARCH=x86_64
else
ifeq ($(MYARCH),ia64)
ARCH=ia64
else
ifeq ($(MYARCH),armeb)
ARCH=arm
else
$(error unknown architecture, please fix Makefile)
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif

# ARCH=$(MYARCH)

OBJDIR=bin-$(ARCH)
ILIBDIR=$(LIBDIR)-$(ARCH)

HOME=$(shell pwd)

WHAT=	$(OBJDIR) $(OBJDIR)/start.o $(OBJDIR)/dyn_start.o $(OBJDIR)/dyn_stop.o \
	$(OBJDIR)/dietlibc.a $(OBJDIR)/liblatin1.a \
	$(OBJDIR)/libcompat.a $(OBJDIR)/libm.a \
	$(OBJDIR)/librpc.a $(OBJDIR)/libpthread.a \
	$(OBJDIR)/libcrypt.a \
	$(OBJDIR)/diet $(OBJDIR)/diet-i $(OBJDIR)/elftrunc \
	$(OBJDIR)/dnsd

all: $(WHAT)

profiling: $(OBJDIR)/libgmon.a $(OBJDIR)/pstart.o

CFLAGS=-pipe -nostdinc
CROSS=

CC=gcc
INC=-I. -isystem include

VPATH=lib:libstdio:libugly:libcruft:libcrypt:libshell:liblatin1:libcompat:libdl:librpc:libregex:libm:profiling

SYSCALLOBJ=$(patsubst syscalls.s/%.S,$(OBJDIR)/%.o,$(wildcard syscalls.s/*.S))

LIBOBJ=$(patsubst lib/%.c,$(OBJDIR)/%.o,$(wildcard lib/*.c))
LIBUGLYOBJ=$(patsubst libugly/%.c,$(OBJDIR)/%.o,$(wildcard libugly/*.c))
LIBSTDIOOBJ=$(patsubst libstdio/%.c,$(OBJDIR)/%.o,$(wildcard libstdio/*.c))
LIBCRUFTOBJ=$(patsubst libcruft/%.c,$(OBJDIR)/%.o,$(wildcard libcruft/*.c))
LIBCRYPTOBJ=$(patsubst libcrypt/%.c,$(OBJDIR)/%.o,$(wildcard libcrypt/*.c))
LIBSHELLOBJ=$(patsubst libshell/%.c,$(OBJDIR)/%.o,$(wildcard libshell/*.c))
LIBCOMPATOBJ=$(patsubst libcompat/%.c,$(OBJDIR)/%.o,$(wildcard libcompat/*.c)) $(OBJDIR)/syscall.o
LIBMATH=$(patsubst libm/%.c,%.o,$(wildcard libm/*.c))

LIBRPCOBJ=$(patsubst librpc/%.c,$(OBJDIR)/%.o,$(wildcard librpc/*.c))
LIBREGEXOBJ=$(patsubst libregex/%.c,$(OBJDIR)/%.o,$(wildcard libregex/*.c))

LIBDLOBJ=$(patsubst libdl/%.c,$(OBJDIR)/%.o,$(wildcard libdl/*.c)) $(OBJDIR)/_dl_jump.o

LIBPTHREAD_OBJS=$(patsubst libpthread/%.c,$(OBJDIR)/%.o,$(shell ./threadsafe.sh)) $(OBJDIR)/__testandset.o

LIBGMON_OBJS=$(OBJDIR)/__mcount.o $(OBJDIR)/monitor.o $(OBJDIR)/profil.o

include $(ARCH)/Makefile.add

LIBMATHOBJ=$(patsubst %,$(OBJDIR)/%,$(LIBMATH))

ifeq ($(CFLAGS),-pipe -nostdinc)
CFLAGS+=-O -fomit-frame-pointer
endif

ifneq ($(DEBUG),)
CFLAGS = -g
COMMENT = :
endif
CFLAGS += -W -Wall -Wextra -Wchar-subscripts -Wmissing-prototypes -Wmissing-declarations -Wno-switch -Wno-unused -Wredundant-decls

PWD=$(shell pwd)

.SUFFIXES:
.SUFFIXES: .S .c

# added real dynamic dietlibc.so
PICODIR = pic-$(ARCH)

$(OBJDIR) $(PICODIR):
	mkdir $@

% :: %,v

$(OBJDIR)/%: $(OBJDIR)

ifeq ($(CC),tcc)
$(OBJDIR)/%.o: %.S $(ARCH)/syscalls.h
	$(CROSS)cpp $(INC) $< | $(CROSS)as -o $@

$(OBJDIR)/%.o: %.c
	tcc -I. -Iinclude -c $< -o $@
	$(COMMENT) -$(CROSS)strip -x -R .comment -R .note $@
else
$(OBJDIR)/pstart.o: start.S
	$(CROSS)$(CC) $(INC) $(CFLAGS) -DPROFILING -c $< -o $@

$(OBJDIR)/%.o: %.S $(ARCH)/syscalls.h
	$(CROSS)$(CC) $(INC) $(CFLAGS) -c $< -o $@

$(OBJDIR)/pthread_%.o: libpthread/pthread_%.c
	$(CROSS)$(CC) $(INC) $(CFLAGS) -c $< -o $@
	$(COMMENT) -$(CROSS)strip -x -R .comment -R .note $@

$(OBJDIR)/%.o: %.c
	$(CROSS)$(CC) $(INC) $(CFLAGS) -c $< -o $@ -D__dietlibc__
	$(COMMENT) -$(CROSS)strip -x -R .comment -R .note $@
endif

ifeq ($(shell $(CC) -v 2>&1 | grep "gcc version"),gcc version 4.0.0)
SAFE_CFLAGS=$(shell echo $(CFLAGS)|sed 's/-Os/-O2/')
SAFER_CFLAGS=$(shell echo $(CFLAGS)|sed 's/-Os/-O/')
else
SAFE_CFLAGS=$(CFLAGS)
SAFER_CFLAGS=$(CFLAGS)
endif

CC+=-D__dietlibc__

$(OBJDIR)/crypt.o: libcrypt/crypt.c
	$(CROSS)$(CC) $(INC) $(SAFER_CFLAGS) -c $< -o $@

DIETLIBC_OBJ = $(OBJDIR)/unified.o \
$(SYSCALLOBJ) $(LIBOBJ) $(LIBSTDIOOBJ) $(LIBUGLYOBJ) \
$(LIBCRUFTOBJ) $(LIBCRYPTOBJ) $(LIBSHELLOBJ) $(LIBREGEXOBJ) \
$(OBJDIR)/__longjmp.o $(OBJDIR)/setjmp.o \
$(OBJDIR)/clone.o

$(OBJDIR)/dietlibc.a: $(DIETLIBC_OBJ) $(OBJDIR)/start.o
	$(CROSS)ar cru $@ $(DIETLIBC_OBJ)

$(OBJDIR)/librpc.a: $(LIBRPCOBJ)
	$(CROSS)ar cru $@ $(LIBRPCOBJ)

$(OBJDIR)/libcrypt.a:
	touch dummy.c
	$(CROSS)$(CC) -c dummy.c
	$(CROSS)ar cru $@ dummy.o
	rm -f dummy.c dummy.o

dummy.o:

LIBLATIN1_OBJS=$(patsubst liblatin1/%.c,$(OBJDIR)/%.o,$(wildcard liblatin1/*.c))
$(OBJDIR)/liblatin1.a: $(LIBLATIN1_OBJS)
	$(CROSS)ar cru $@ $^

$(OBJDIR)/libgmon.a: $(LIBGMON_OBJS)
	$(CROSS)ar cru $@ $^

$(OBJDIR)/libpthread.a: $(LIBPTHREAD_OBJS) dietfeatures.h
	$(CROSS)ar cru $@ $(LIBPTHREAD_OBJS)

$(OBJDIR)/libcompat.a: $(LIBCOMPATOBJ)
	$(CROSS)ar cru $@ $(LIBCOMPATOBJ)

$(OBJDIR)/libm.a: $(LIBMATHOBJ)
	$(CROSS)ar cru $@ $(LIBMATHOBJ)

LD_UNSET = env -u LD_RUN_PATH

dyn: dyn_lib

# added dynamic linker
$(OBJDIR)/libdl.a: $(LIBDLOBJ)
	$(CROSS)ar cru $@ $(LIBDLOBJ)

dyn_lib: $(PICODIR) $(PICODIR)/libc.so $(PICODIR)/dstart.o \
	$(PICODIR)/dyn_so_start.o $(PICODIR)/dyn_start.o $(PICODIR)/dyn_stop.o \
	$(PICODIR)/libpthread.so $(PICODIR)/libdl.so $(PICODIR)/libcompat.so \
	$(PICODIR)/libm.so $(PICODIR)/diet-dyn $(PICODIR)/diet-dyn-i

$(PICODIR)/%.o: %.S $(ARCH)/syscalls.h
	$(CROSS)$(CC) $(INC) $(CFLAGS) -fPIC -D__DYN_LIB -c $< -o $@

$(PICODIR)/pthread_%.o: libpthread/pthread_%.c
	$(CROSS)$(CC) $(INC) $(CFLAGS) -fPIC -D__DYN_LIB -c $< -o $@
	$(COMMENT) $(CROSS)strip -x -R .comment -R .note $@

$(PICODIR)/%.o: %.c
	$(CROSS)$(CC) $(INC) $(CFLAGS) -fPIC -D__DYN_LIB -c $< -o $@
	$(COMMENT) $(CROSS)strip -x -R .comment -R .note $@

$(PICODIR)/dstart.o: start.S
	$(CROSS)$(CC) $(INC) $(CFLAGS) -fPIC -D__DYN_LIB -c $< -o $@

$(PICODIR)/dyn_so_start.o: dyn_start.c
	$(CROSS)$(CC) $(INC) $(CFLAGS) -fPIC -D__DYN_LIB -D__DYN_LIB_SHARED -c $< -o $@
	$(COMMENT) $(CROSS)strip -x -R .comment -R .note $@

DYN_LIBC_PIC = $(LIBOBJ) $(LIBSTDIOOBJ) $(LIBUGLYOBJ) \
$(LIBCRUFTOBJ) $(LIBCRYPTOBJ) $(LIBSHELLOBJ) $(LIBREGEXOBJ)

DYN_LIBC_OBJ = $(PICODIR)/dyn_syscalls.o $(PICODIR)/errlist.o \
	$(patsubst $(OBJDIR)/%.o,$(PICODIR)/%.o,$(DYN_LIBC_PIC))

DYN_PTHREAD_OBJS = $(patsubst $(OBJDIR)/%.o,$(PICODIR)/%.o,$(LIBPTHREAD_OBJS))

DYN_LIBDL_OBJS = $(patsubst $(OBJDIR)/%.o,$(PICODIR)/%.o,$(LIBDLOBJ))

DYN_LIBCOMPAT_OBJS = $(patsubst $(OBJDIR)/%.o,$(PICODIR)/%.o,$(LIBCOMPATOBJ))

DYN_LIBMATH_OBJS = $(patsubst $(OBJDIR)/%.o,$(PICODIR)/%.o,$(LIBMATHOBJ))

$(PICODIR)/libc.so: $(PICODIR) $(DYN_LIBC_OBJ)
	$(LD_UNSET) $(CROSS)$(CC) -nostdlib -shared -o $@ $(CFLAGS) -fPIC $(DYN_LIBC_OBJ) -lgcc -Wl,-soname=libc.so

$(PICODIR)/libpthread.so: $(DYN_PTHREAD_OBJS) dietfeatures.h
	$(LD_UNSET) $(CROSS)$(CC) -nostdlib -shared -o $@ $(CFLAGS) -fPIC $(DYN_PTHREAD_OBJS) -L$(PICODIR) -lc -Wl,-soname=libpthread.so

$(PICODIR)/libdl.so: libdl/_dl_main.c dietfeatures.h
	$(LD_UNSET) $(CROSS)$(CC) -D__OD_CLEAN_ROOM -DNODIETREF -fPIC -nostdlib -shared -Bsymbolic -Wl,-Bsymbolic \
		-o $@ $(SAFE_CFLAGS) $(INC) libdl/_dl_main.c -Wl,-soname=libdl.so

$(OBJDIR)/pthread_create.o $(PICODIR)/pthread_create.o: dietfeatures.h
$(OBJDIR)/pthread_internal.o $(PICODIR)/pthread_internal.o: dietfeatures.h

#$(PICODIR)/libdl.so: $(DYN_LIBDL_OBJS) dietfeatures.h
#	$(CROSS)$(CC) -nostdlib -shared -o $@ $(CFLAGS) -fPIC $(DYN_LIBDL_OBJS) -L$(PICODIR) -ldietc -Wl,-soname=libdl.so

$(PICODIR)/libcompat.so: $(DYN_LIBCOMPAT_OBJS) dietfeatures.h
	$(LD_UNSET) $(CROSS)$(CC) -nostdlib -shared -o $@ $(CFLAGS) -fPIC $(DYN_LIBCOMPAT_OBJS) -L$(PICODIR) -lc -Wl,-soname=libcompat.so

$(PICODIR)/libm.so: $(DYN_LIBMATH_OBJS) dietfeatures.h
	$(LD_UNSET) $(CROSS)$(CC) -nostdlib -shared -o $@ $(CFLAGS) -fPIC $(DYN_LIBMATH_OBJS) -L$(PICODIR) -lc -Wl,-soname=libm.so


$(SYSCALLOBJ): syscalls.h

$(OBJDIR)/elftrunc: $(OBJDIR)/diet contrib/elftrunc.c
	bin-$(MYARCH)/diet $(CROSS)$(CC) $(CFLAGS) -o $@ contrib/elftrunc.c

$(OBJDIR)/dnsd: $(OBJDIR)/diet contrib/dnsd.c
	bin-$(MYARCH)/diet $(CROSS)$(CC) $(CFLAGS) -o $@ contrib/dnsd.c

VERSION=dietlibc-$(shell head -n 1 CHANGES|sed 's/://')
CURNAME=$(notdir $(shell pwd))

$(OBJDIR)/diet: $(OBJDIR)/start.o $(OBJDIR)/dyn_start.o diet.c $(OBJDIR)/dietlibc.a $(OBJDIR)/dyn_stop.o
	$(CROSS)$(CC) -isystem include $(CFLAGS) -nostdlib -o $@ $^ -DDIETHOME=\"$(HOME)\" -DVERSION=\"$(VERSION)\" -lgcc
	$(CROSS)strip -R .comment -R .note $@

$(OBJDIR)/diet-i: $(OBJDIR)/start.o $(OBJDIR)/dyn_start.o diet.c $(OBJDIR)/dietlibc.a $(OBJDIR)/dyn_stop.o
	$(CROSS)$(CC) -isystem include $(CFLAGS) -nostdlib -o $@ $^ -DDIETHOME=\"$(prefix)\" -DVERSION=\"$(VERSION)\" -DINSTALLVERSION -lgcc
	$(CROSS)strip -R .comment -R .note $@

$(PICODIR)/diet-dyn: $(PICODIR)/start.o $(PICODIR)/dyn_start.o diet.c
	$(LD_UNSET) $(CROSS)$(CC) -isystem include $(CFLAGS) -fPIC -nostdlib -o $@ $^ -DDIETHOME=\"$(HOME)\" -D__DYN_LIB -DVERSION=\"$(VERSION)\" -L$(PICODIR) -lc -lgcc $(PICODIR)/dyn_stop.o -Wl,-dynamic-linker=$(HOME)/$(PICODIR)/libdl.so
	$(CROSS)strip -R .command -R .note $@

$(PICODIR)/diet-dyn-i: $(PICODIR)/start.o $(PICODIR)/dyn_start.o diet.c
	$(LD_UNSET) $(CROSS)$(CC) -isystem include $(CFLAGS) -fPIC -nostdlib -o $@ $^ -DDIETHOME=\"$(prefix)\" -D__DYN_LIB -DVERSION=\"$(VERSION)\" -L$(PICODIR) -lc -lgcc $(PICODIR)/dyn_stop.o -Wl,-dynamic-linker=$(ILIBDIR)/libdl.so -DINSTALLVERSION
	$(CROSS)strip -R .command -R .note $@

$(OBJDIR)/djb: $(OBJDIR)/compile $(OBJDIR)/load

$(OBJDIR)/compile:
	echo 'exec' $(CC) '$(CFLAGS) -I$(PWD)/$(OBJDIR)/include -c $${1+"$$@"}' > $@
	chmod 755 $@

$(OBJDIR)/load:
	echo 'main="$$1"; shift; exec' $(CC) '-nostdlib -o "$$main" $(PWD)/$(OBJDIR)/start.o "$$main".o $${1+"$$@"} $(PWD)/$(OBJDIR)/dietlibc.a -lgcc'  > $@
	chmod 755 $@

clean:
	rm -f *.o *.a t t1 compile load elftrunc exports mapfile libdietc.so
	rm -rf bin-* pic-*
	$(MAKE) -C examples clean
	$(MAKE) -C dynlinker clean
	$(MAKE) -C libdl clean

tar: clean rename
	cd ..; tar cvvf $(VERSION).tar.bz2 --use=bzip2 --exclude CVS $(VERSION)

rename:
	if test $(CURNAME) != $(VERSION); then cd .. && mv $(CURNAME) $(VERSION); fi

$(OBJDIR)/exports: $(OBJDIR)/dietlibc.a
	nm -g $(OBJDIR)/dietlibc.a | grep '\<T\>' | awk '{ print $$3 }' | sort -u > $(OBJDIR)/exports

.PHONY: t t1
t:
	$(CROSS)$(CC) -g $(CFLAGS) -fno-builtin -nostdlib -isystem include -o t t.c $(OBJDIR)/start.o $(OBJDIR)/dyn_start.o $(OBJDIR)/dietlibc.a -lgcc $(OBJDIR)/dyn_stop.o -Wl,-Map,mapfile

t1:
	$(CROSS)$(CC) -g -o t1 t.c

install-bin: $(OBJDIR)/start.o $(OBJDIR)/dietlibc.a $(OBJDIR)/librpc.a $(OBJDIR)/liblatin1.a $(OBJDIR)/libcompat.a $(OBJDIR)/elftrunc $(OBJDIR)/diet-i
	$(INSTALL) -d $(DESTDIR)$(ILIBDIR) $(DESTDIR)$(MAN1DIR) $(DESTDIR)$(BINDIR)
	$(INSTALL) $(OBJDIR)/start.o $(DESTDIR)$(ILIBDIR)/start.o
	$(INSTALL) -m 644 $(OBJDIR)/libm.a $(OBJDIR)/libpthread.a $(OBJDIR)/librpc.a \
$(OBJDIR)/liblatin1.a $(OBJDIR)/libcompat.a $(OBJDIR)/libcrypt.a $(DESTDIR)$(ILIBDIR)
	$(INSTALL) -m 644 $(OBJDIR)/dietlibc.a $(DESTDIR)$(ILIBDIR)/libc.a
ifeq ($(MYARCH),$(ARCH))
	$(INSTALL) $(OBJDIR)/diet-i $(DESTDIR)$(BINDIR)/diet
	-$(INSTALL) $(PICODIR)/diet-dyn-i $(DESTDIR)$(BINDIR)/diet-dyn
endif
	$(INSTALL) -m 755 $(OBJDIR)/elftrunc $(OBJDIR)/dnsd $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 644 diet.1 $(DESTDIR)$(MAN1DIR)/diet.1

install-profiling:

=== libpthread/Makefile ===
all: libpthread.a

M=$(shell ../findcflags.sh $(CC))

ARCH=$(shell uname -m | sed 's/i[4-9]86/i386/')

CFLAGS= -g #-pipe -O -march=k6
CFLAGS= -pipe
CROSS=

CC=gcc

VPATH=../$(ARCH)/

PTHREAD_OBJS = __testandset.o $(patsubst %.c,%.o,$(wildcard pthread_*.c))

TESTS = $(patsubst %.c,%,$(wildcard test-*.c))

%.o : %.c
	$(CC) $(CFLAGS) -c -o $@ $?

#include ../$(ARCH)/Makefile.add

ifeq ($(CFLAGS),-pipe)
CFLAGS+= -O2 -fomit-frame-pointer
endif

CFLAGS += -W -Wall
#CFLAGS += -fPIC

CFLAGS += -I. -I.. -I../include -Wall


PWD=$(shell pwd)

.SUFFIXES:
.SUFFIXES: .S .c

.PHONY: clean tests test.out

% :: %,v

%.o: %.S
	$(CROSS)$(CC) -I. -Iinclude $(CFLAGS) -c $<

%.o: %.c
	$(CROSS)$(CC) -I. -Iinclude $(CFLAGS) -c $<
#	$(CROSS)strip -x -R .comment -R .note $@

libpthread.a: $(PTHREAD_OBJS)
	$(CROSS)ar cr $@ $^

libpthread.so: libpthread.a
	$(CROSS)ld -whole-archive -shared -o $@ $^


clean: tests-clean
	$(RM) *.o *.a *.so *.out *~ *.oa

exports: libpthread.a
	nm -g libpthread.a | grep -w T | awk '{ print $$3 }' | sort -u > exports

.PHONY: test.out

test.out: test.o libpthread.a $(LIBS)
	$(CROSS)$(CC) -g $(CFLAGS) -nostdlib ../bin-$(ARCH)/start.o ../bin-$(ARCH)/dyn_start.o -o $@ $^ ../bin-$(ARCH)/dietlibc.a -lgcc ../bin-$(ARCH)/dyn_stop.o

tests: tests-clean $(TESTS)

tests-clean:
	$(RM) $(TESTS)

# libpthread.a
pthread.oa: $(PTHREAD_OBJS)
	ld -r -o $@ $(patsubst pthread_errno.o,,$^)

$(TESTS): pthread.oa
	$(CROSS)$(CC) -g $(CFLAGS) -nostdlib ../bin-$(ARCH)/start.o ../bin-$(ARCH)/dyn_start.o -o $@ $@.c $^ ../bin-$(ARCH)/dietlibc.a -lgcc ../bin-$(ARCH)/dyn_stop.o

.PHONY: sparc ppc mips arm alpha i386

sparc ppc alpha i386:
	$(MAKE) ARCH=$@ CROSS=$@-linux- all t libdietc.so

mips arm:
	$(MAKE) ARCH=$@ CROSS=$@-linux- all t libdietc.so

=== test/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-all: direnttest inet stdiotests stdlibtests stringtests timetests \
+all: direnttest inettest stdiotests stdlibtests stringtests timetests \
 test ffs getdelim stdlib 
 
 DIET=diet

=== test/dirent/Makefile ===
DIET=diet
CC=gcc
CFLAGS=-Wall

all: dirent

TESTPROGRAMS=opendir-tst1 tst-seekdir

dirent: $(TESTPROGRAMS)

%: %.c
	$(DIET) $(CC) $(CFLAGS) $^ -o $@

clean:
	rm -f $(TESTPROGRAMS)

=== test/stdio/Makefile ===
DIET=diet
CC=gcc
CFLAGS=-Wall -nostdinc
LCOMPAT=-lcompat

all: stdiotest tstgetln

TESTPROGRAMS=tst-ferror tstdiomisc tst-fdopen tst-fileno \
tst-fphex tst-fseek tst-printf tstscanf tst-sprintf tst-sscanf tst-tmpnam \
tst-unbputc tst-ungetc

stdiotest: $(TESTPROGRAMS)

%: %.c
	$(DIET) $(CC) $(CFLAGS) $^ -o $@

tstgetln: tstgetln.c
	$(DIET) $(CC) $(CFLAGS) $^ $(LCOMPAT) -o $@

clean:
	rm -f $(TESTPROGRAMS) tstgetln

=== test/string/Makefile ===
DIET=diet
CC=gcc
CFLAGS=-Wall -fno-builtin

all: stringtest

TESTPROGRAMS=memccpy memchr memcmp memcpy memrchr strcasecmp strcmp strlen strncat strncpy strrchr strstr \
strspn strcspn strpbrk mempcpy

stringtest: $(TESTPROGRAMS)

%: %.c
	$(DIET) $(CC) $(CFLAGS) $^ -o $@

mempcpy: mempcpy.c
	$(DIET) $(CC) $(CFLAGS) $^ -o $@ -lcompat

clean:
	rm -f $(TESTPROGRAMS)

=== debian/changelog ===
dietlibc (0.33~cvs20120325-6) unstable; urgency=low

  * Team upload.
  * Upload to unstable
  * debian/watch: Update for new download location, 0.33 is out
  * Remove myself from Uploaders
  * debian/control: Use canonical VCS-* URI, says lintian

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 11 Feb 2014 21:48:06 +0100

dietlibc (0.33~cvs20120325-5) experimental; urgency=low

  [ Roland Stigge ]
  * Add support for the https://wiki.debian.org/PowerPCSPEPort
    (Closes: #694366)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 25 Nov 2012 21:41:02 +0000

dietlibc (0.33~cvs20120325-4) unstable; urgency=low

  [ Peter Michael Green ]
  * Tweak arm assembler patch so it works with armv6 vfp too.

  [ Thorsten Glaser ]
  * Fix jmp_buf size for armhf (Closes: #689222)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 30 Sep 2012 14:15:34 +0000

dietlibc (0.33~cvs20120325-3) unstable; urgency=low

  * Make the select testcase we run at build-time actually useful
  * Fix #394928 on ppc64, too (same patch, different directory)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 27 Mar 2012 20:18:03 +0000

dietlibc (0.33~cvs20120325-2) unstable; urgency=low

  * Upstream added a real mipsel port, use it instead of saying mips

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 26 Mar 2012 19:01:10 +0000

dietlibc (0.33~cvs20120325-1) unstable; urgency=low

  * Fix compile time warning (utimes undeclared) on armel, armhf, ia64
  * Policy 3.9.3 (no relevant changes)
  * Add VCS-* fields to debian/control
  * Take new upstream CVS snapshot (CVE-2012-1577)
  * Add -fno-strict-aliasing to files that emit a warning otherwise
  * Drop patches merged upstream

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 25 Mar 2012 15:52:21 +0000

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,13 @@
 Priority: optional
 Homepage: http://www.fefe.de/dietlibc/
 Maintainer: Hector Oron <zumbi@debian.org>
-Uploaders: Thorsten Glaser <tg@mirbsd.de>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
+Vcs-git: git://anonscm.debian.org/collab-maint/dietlibc.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/dietlibc.git
 
 Package: dietlibc-dev
 Section: libdevel
-Architecture: alpha amd64 arm armeb armel armhf hppa i386 ia64 mips mipsel powerpc ppc64 s390 s390x sparc sparc64
+Architecture: alpha amd64 arm armeb armel armhf hppa i386 ia64 mips mipsel powerpc powerpcspe ppc64 s390 s390x sparc sparc64
 Suggests: dietlibc-doc
 Description: diet libc - a libc optimized for small size
  The diet libc is a C library that is optimized for small size. It

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #!/usr/bin/make -f
 
 # for "debian/rules get-orig-source"
-ORIGTGZ_SOURCE:=	-D'2011/11/08 20:00'
-ORIGTGZ_DESTINATION:=	0.33~cvs20111108
+ORIGTGZ_SOURCE:=	-D'2012/03/25 15:00'
+ORIGTGZ_DESTINATION:=	0.33~cvs20120325
 
 # determine whether we are cross-compiling
 DEB_BUILD_GNU_TYPE:=$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
@@ -26,11 +26,11 @@
 ifeq ($(ARCH),powerpc)
   ARCH =ppc
 else
+ifeq ($(ARCH),powerpcspe)
+  ARCH =ppc
+else
 ifeq ($(ARCH),hppa)
   ARCH =parisc
-else
-ifeq ($(ARCH),mipsel)
-  ARCH =mips
 else
 ifneq (,$(findstring arm,$(ARCH)))
   ARCH =arm
@@ -162,12 +162,8 @@
 
 _ANONCVSROOT:=		:pserver:cvs@cvs.fefe.de:/cvs
 _CVSEXPORT:=		env CVS_RSH=ssh TZ=UTC cvs -qd ${_ANONCVSROOT} -z9 export
-ifneq (,$(wildcard /usr/bin/mircpio))
 _PACK:=			find dietlibc-${ORIGTGZ_DESTINATION} -type f | sort | \
-			    mircpio -oC512 -Hustar -Mdist
-else
-_PACK:=			tar -cf - dietlibc-${ORIGTGZ_DESTINATION}
-endif
+			    paxcpio -oC512 -Hustar -Mdist
 
 get-orig-source:
 	rm -rf $@.tmp

=== debian/watch ===
version=3
http://www.fefe.de/dietlibc/ dietlibc-([0-9.]*)\.tar\.bz2
